######################################################################
# tbl2 vOC
#
# :p: (Ƃ html  dl) ̃CAEgCɓȂ̂ŁA
# ̑pƂẮA2Ɍ肵e[up̃vOCSłB
#
# tbl2_ Ŏn܂ȉ̃̕vOCpăe[uLqł܂B
#
#     #tbl2(w1, w2, ...)	\\ <table w1 w2 ... >
#     #tbl2_th					\\ <th>
#     #tbl2_td					\\ <td>
#     #tbl2_end 				\\ </table>
#
# LhtmllɋLq邱ƂɂȂ܂B
#
# A#tbl2`#tbl2_end̊Ԃł͋sȂłB
# sƂ<table>Ƃ͖`<div><p>ꍇ܂B
#
# w <table>̑ƁAcolgroup,td,th̎w肪X.
# E<table>̑
#    width,rules,border,cellpadding,cellspacing,align,bgcolor,class
#     width=90% ̂悤Ɏw(""ň͂܂Ȃ)
# E1߂<colgroup>p
#    width1=.   <colgroup width=""> w.
# E<th><td>p
#    walign=ʒu  <th><td>łalignw
#    valign=cʒu  <th><td>łvalignw
#    bgcolor1=F    <th>ɑ΂bgcolorw
#    bgcolor2=F    <td>ɑ΂bgcolorw
# Eclear           table<div style="clear:all"> 𐶐
# Enoclear         table<div style="clear:all"> 𐶐Ȃ
#
# classŵȂꍇ́Atbl2_default NXƂȂ܂B
#
# ̃vOCpsAL~XƂ̃G[`FbN͊Â̂
# CĂĂB(šƂ)
# {ȂWiki{̑ق悳ȗނ̋@\...
# x̂ŁAǂȂgɂ́AŁB

# 2006-03-21 tenk*
# License: GPL2 and/or Artistic or each later version
######################################################################


tbl2_init();

sub tbl2_init {
	$tbl2::state=0;
	$tbl2::class_name='tbl2_default';

	# $tbl2::bgcolorfmt='bgcolor="%s"';
	$tbl2::bgcolorfmt='style="background-color:%s;"';

	# <table>p
	$tbl2::width='90%';
	$tbl2::rules='none';
	$tbl2::border='0';
	$tbl2::cellpadding='3';
	$tbl2::cellspacing='1';
	$tbl2::align='center';
	$tbl2::bgcolor='';

	# <colgroup>p
	$tbl2::width1='';

	# <th><td>p
	$tbl2::walign='left';
	$tbl2::valign='middle';
	$tbl2::bgcolor1='';			# <th>̔wiF. ''Ɩ
	$tbl2::bgcolor2='';			# <td>̔wiF. ''Ɩ

	# Ip
	$tbl2::clear_all=1;
}


sub plugin_tbl2_convert {
	return plugin_tbl2_inline(@_);
}

sub plugin_tbl2_inline {
	return 'tbl2 ERROR:bad state(0)\n' if ($tbl2::state != 0);
	$tbl2::state=1;
	my $body;
	foreach my $arg(split(/,/, shift)) {
		$arg = trim($arg);
		if ($arg =~ /^width1=(.+)/) {
			$tbl2::width1=$1;
		} elsif ($arg =~ /^width=(.+)/) {
			$tbl2::width=$1;
		} elsif ($arg =~ /^rules=(none|all|rows|col)/) {
			$tbl2::rules=$1;
		} elsif ($arg =~ /^border=(\d+)/) {
			$tbl2::border=$1;
		} elsif ($arg =~ /^cellpadding=(\d+)/) {
			$tbl2::cellpadding=$1;
		} elsif ($arg =~ /^cellspacing=(\d+)/) {
			$tbl2::cellspacing=$1;
		} elsif ($arg =~ /^align=(center|left|right)/) {
			$tbl2::align=$1;
		} elsif ($arg =~ /^walign=(center|left|right|justify|char)/) {
			$tbl2::walign=$1;
		} elsif ($arg =~ /^valign=(top|middle|bottom|baseline)/) {
			$tbl2::valign=$1;
		} elsif ($arg =~ /^bgcolor=\#(\w+)/) {
			$tbl2::bgcolor="#$1";
		} elsif ($arg =~ /^bgcolor1=\#(\w+)/) {
			$tbl2::bgcolor1="#$1";
		} elsif ($arg =~ /^bgcolor2=\#(\w+)/) {
			$tbl2::bgcolor2="#$1";
		} elsif ($arg =~ /^class=(.*)/) {
			$tbl2::class_name=$1;
		} elsif ($arg =~ /^noclear$/) {
			$tbl2::clear_all=0;
		} elsif ($arg =~ /^clear$/) {
			$tbl2::clear_all=1;
		}
	}

	my $width		= "width=\"$tbl2::width\""				if ($tbl2::width ne '');
	my $rules		= "rules=\"$tbl2::rules\""				if ($tbl2::rules ne '');
	my $border		= "border=\"$tbl2::border\""			if ($tbl2::border ne '');
	my $cellpadding	= "cellpadding=\"$tbl2::cellpadding\""	if ($tbl2::cellpadding ne '');
	my $cellspacing	= "cellspacing=\"$tbl2::cellspacing\""	if ($tbl2::cellspacing ne '');
	my $align		= "align=\"$tbl2::align\""				if ($tbl2::align ne '');
	my $class		= "class=\"$tbl2::class_name\""			if ($tbl2::class_name ne '');
	# my $bgcolor		= "bgcolor=\"$tbl2::bgcolor\""		if ($tbl2::bgcolor ne '');
	my $bgcolor		= sprintf($tbl2::bgcolorfmt, $tbl2::bgcolor)	if ($tbl2::bgcolor ne '');

	$body.="<table $width $rules $border $cellpadding $cellspacing $align $class $bgcolor>\n";
	$body.="<colgroup width=\"$tbl2::width1\" />\n" if ($tbl2::width1 ne '');

	return $body;
};
1
__END__
